<template>
  <div>
    <v-dialog
      v-model="dialog"
      scrollable
      persistent
      max-width="1000"
      attach="#app"
    >
      <v-card>
        <v-card-title
          class="pl-4 pr-1 py-1 text-subtitle-1 primary white--text"
        >
          {{ $t("tool.page.about.title") }}
          <v-spacer />
          <GIconBtn
            i18n="form.close"
            icon="mdi-close"
            small
            small-btn
            btn-class="theme--dark"
            @click="$emit('toggle')"
          />
        </v-card-title>
        <v-card-text>
          <div class="v-card-group">
            <v-card>
              <v-card-title>
                <h2 class="font-weight-thin">
                  {{ $t("tool.page.about.issue.found") }}
                </h2>
              </v-card-title>
              <v-card-actions>
                <v-btn
                  color="primary"
                  class="pa-3"
                  target="_blank"
                  href="https://gitlab.com/ptb/dcc/gemimeg-tool/issues/new?issue"
                >
                  {{ $t("tool.page.about.issue.gitlab") }}
                </v-btn>
                <v-btn
                  color="success"
                  class="pa-3"
                  href="mailto:gemimeg@ptb.de"
                >
                  {{ $t("tool.page.about.issue.email") }}
                </v-btn>
              </v-card-actions>
            </v-card>
            <v-card v-if="dev">
              <v-card-title>
                <h2 class="font-weight-thin">
                  {{ $t("tool.page.about.dev") }}
                </h2>
              </v-card-title>
            </v-card>
            <v-card>
              <v-card-title>
                <h2 class="font-weight-thin">
                  {{ $t("tool.page.about.version", [version]) }}
                </h2>
              </v-card-title>
            </v-card>
            <v-card>
              <v-card-title class="text-break">
                <h2 class="font-weight-thin">
                  {{
                    $t("general.ptbCopyright", { year: $config.copyrightYear })
                  }}
                </h2>
                <br />
                {{ $t("tool.page.about.license") }}
              </v-card-title>
            </v-card>
            <v-card>
              <v-card-title>
                <h2 class="font-weight-thin">
                  {{ $t("tool.page.about.credits.title") }}
                </h2>
              </v-card-title>
              <v-card-text>
                <p>{{ $t("tool.page.about.credits.text") }}</p>

                <v-text-field
                  v-model="search"
                  append-icon="search"
                  :label="$t('form.search')"
                  single-line
                  hide-details
                />

                <v-data-table
                  :headers="headers"
                  :items="items"
                  :search="search"
                >
                  <template #item="props">
                    <tr>
                      <td>{{ props.item.name }}</td>
                      <td>{{ props.item.version }}</td>
                      <td>{{ props.item.license }}</td>
                      <td>{{ props.item.authors }}</td>
                      <td class="justify-center">
                        <a
                          target="_blank"
                          :href="props.item.url"
                          style="text-decoration: none"
                        >
                          <v-icon small class="mr-2">language</v-icon>
                        </a>
                      </td>
                    </tr>
                  </template>
                </v-data-table>
              </v-card-text>
            </v-card>
          </div>
        </v-card-text>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import GIconBtn from "~/components/App/Common/GIconBtn.vue";
export default {
  name: "About",
  components: { GIconBtn },
  props: {
    dialog: Boolean,
  },
  data() {
    return {
      version: process.env.version,
      dev: process.env.NODE_ENV !== "production",
      headers: [
        {
          text: "Name",
          value: "name",
        },
        { text: "Version", value: "version" },
        { text: "License", value: "license" },
        { text: "Authors", value: "authors" },
        { text: "Actions", value: "actions" },
      ],
      items: [],
      search: "",
    };
  },
  mounted() {
    if (!process.client) return;
    try {
      // eslint-disable-next-line @typescript-eslint/no-var-requires
      const credits = require("~/assets/credits.json");
      this.items = Object.values(credits);
    } catch (e) {
      this.$logger.error("Could not load credits.", e);
    }
    this.items = this.items.concat(this.$tool.getCredits());
  },
};
</script>
